############################################################
#
# <p>Leafmap Map</p>
# <pre>
# {{llmap ,[,,ι⤵,ޥåפɽΨ,ޥåפΥ]}}
# </pre>
#
############################################################
package plugin::leaflet::llmap;
use strict;

#===========================================================
# 󥹥ȥ饯
#===========================================================
sub new {
  my $class = shift;
  my $self = {};
  $self->{count} = 1;
  return bless $self,$class;
}

#===========================================================
# ѥ饰ե᥽å
#===========================================================
sub paragraph {
  my $self = shift;
  my $wiki = shift;
  my $lat = shift;
  my $lng = shift;
  my $width  = shift;
  my $height  = shift;
  my $zoom  = shift;
  my $type  = shift;

  my $index = $self->{count};
  $self->{count}++;

  if ($width eq "") {
    $width = "400px";
  } else {
    $width .= "px";
  }

  if ($height eq "") {
    $height = "300px";
  } else {
    $height .= "px";
  }

  if ($zoom eq "") {
    $zoom = 16;
  }

  if (($type ne "gsi")&&($type ne "gsiphoto")&&($type ne "osm")) {
    $type = "gsi";
  }

  if (($lat eq "") || ($lng eq "")) {
    $lat = 0;
    $lng = 0;
  }

  my $style = "";
  if ($index == 1) {
    $style = "<link rel=\"stylesheet\" href=\"https://unpkg.com/leaflet\@1.7.1/dist/leaflet.css\" integrity=\"sha512-xodZBNTC5n17Xt2atTPuE1HxjVMSvLVW9ocqUKLsCC5CXdbqCmblAshOMAS6/keqq/sMZMZ19scR4PsZChSR7A==\" crossorigin=\"\"/>";
  }
  $style .="<style>div#leafletmap$index a:link{color:#000000;}</style><style>div#leafletmap$index a:visited{color:#000000;}</style>";

  $wiki->add_head_info($style);

  return <<"__EOD3__";
<div id="leafletmap$index" style="width: $width; height: $height; color:black;"></div>
<script src="https://unpkg.com/leaflet\@1.7.1/dist/leaflet.js"
  integrity="sha512-XQoYMqMTK8LvdxXYG3nZ448hOEQiglfqkJs1NOQV44cWnUrBc8PkAOcXy20w0vlaXaVUearIOBhiXZ5V3ynxwA=="
  crossorigin=""></script>
<script>
  var map = L.map('leafletmap$index',{zoomControl:false});
  map.setView([$lat, $lng], $zoom);
  L.control.scale({maxWidth:200,position:'bottomright',imperial:false}).addTo(map);
  L.control.zoom({position:'bottomleft'}).addTo(map);
  //ϿޤɸϿޥ
  var gsi$index =L.tileLayer('https://cyberjapandata.gsi.go.jp/xyz/std/{z}/{x}/{y}.png', 
    {attribution: "<a href='https://maps.gsi.go.jp/development/ichiran.html' target='_blank'></a>"});
  //Ͽޤμ̿
  var gsiphoto$index = L.tileLayer('https://cyberjapandata.gsi.go.jp/xyz/seamlessphoto/{z}/{x}/{y}.jpg',
    {attribution: "<a href='https://maps.gsi.go.jp/development/ichiran.html' target='_blank'></a>"});
  //ץ󥹥ȥ꡼ȥޥåפΥ
  var osm$index = L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png',
    {attribution: "<a href='https://osm.org/copyright' target='_blank'>OpenStreetMap</a> contributors"});
  //baseMaps֥ȤΥץѥƥ3ĤΥ
  var baseMaps$index = {
    "ɸϿ" : gsi$index,
    "̿" : gsiphoto$index,
    "ץ󥹥ȥ꡼ȥޥå"  : osm$index
  };
  //layersȥbaseMaps֥ȤꤷϿޤɲ
  //ȥ˥ץѥƥ̾ɽ
  L.control.layers(baseMaps$index).addTo(map);
  $type$index.addTo(map);
</script>   
__EOD3__
}

1;
