############################################################
#
# <p>Leaflet Map</p>
# <pre>
# {{lmap [,,ι⤵,ޥåפɽΨ,ޥåפΥ]}}
# </pre>
#
############################################################
package plugin::leaflet::lmap;
use strict;
use Net::SSL;
use Storable qw/nstore retrieve/;
use LWP::UserAgent;
use Encode qw/from_to/;
use JSON qw/decode_json/;

#===========================================================
# 󥹥ȥ饯
#===========================================================
sub new {
  my $class = shift;
  my $self = {};
  return bless $self,$class;
}

#===========================================================
# ѥ饰ե᥽å
#===========================================================
sub paragraph {
  my $self = shift;
  my $wiki = shift;
  my $adr = shift;
  my $width  = shift;
  my $height  = shift;
  my $zoom  = shift;
  my $type  = shift;

  my $cgi = $wiki->get_CGI;
  my $pagename = $cgi->param("page");
  $pagename = &Util::url_encode($pagename);

  unless($self->{"$pagename"}->{count}){
      $self->{"$pagename"}->{count} = 1;
  }
  my $index = $self->{"$pagename"}->{count};
  $self->{"$pagename"}->{count}++;

  my $geo = "";
  my $lat = 0;
  my $lng = 0;

  from_to($adr,"euc-jp","utf8");
  $adr =~ s/([^A-Za-z0-9])/sprintf("%%%02X",ord($1))/seg;

  my $cachefile = $wiki->config('log_dir')."/$pagename.$index.gsi";
  if((-e $cachefile) && !(&newerfile($cachefile, $wiki->config('data_dir')."/$pagename.wiki"))){
    $geo = retrieve $cachefile;
  }else{
    my $url = 'https://msearch.gsi.go.jp/address-search/AddressSearch';
    $url .= '?q='.$adr;
  
    my $ua = LWP::UserAgent->new;
    $ua->ssl_opts(verify_hostname => 0);
    my $res = $ua->get($url);
    if($res->is_success){
      $geo = decode_json($res->content);
      nstore $geo, $cachefile;
    } else {
      return $wiki->paragraph_error("https://msearch.gsi.co.jpؤΥ顼");
    }
  }

  $lng = $geo->[0]->{'geometry'}->{'coordinates'}->[0];
  $lat = $geo->[0]->{'geometry'}->{'coordinates'}->[1];

  my $ret = "{{llmap $lat,$lng,$width,$height,$zoom,$type}}\n";

  return $ret;
}


#==============================================================================
# ե꿷ե뤬ǥ쥯ȥˤ뤫ǧ
#     1:ե뤬Ĥä
#     0:                Ĥʤä
#    -1:顼
#==============================================================================
sub newerfile {
    my $criterion = shift;	# ˤʤե
    my $file = shift;	# Ӥե

  if ((stat($criterion))[9] < (stat($file))[9]){
    return 1;
  }else{
    return 0;
  }
}

1;
